#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2900three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 2900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2900three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three29004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three29004xi = {
                1:'0x2814y-697z',
                2:'1005x661y-2638z',
                3:'1023x2667y-498z',
                4:'1051x2478y-1078z',
                5:'1068x2105y-1683z',
                6:'1071x2301y-1402z',
                7:'111x266y-2885z',
                8:'115x759y-2796z',
                9:'1163x2614y-470z',
                10:'116x2292y-1931z',
                11:'1184x2429y-1051z',
                12:'1185x2061y-1660z',
                13:'1196x2254y-1377z',
                14:'121x107y-2895z',
                15:'1300x2010y-1636z',
                16:'1301x2553y-441z',
                17:'1315x2372y-1024z',
                18:'1320x2200y-1351z',
                19:'137x286y-2882z',
                20:'1413x1952y-1612z',
                21:'1435x2485y-412z',
                22:'1441x2139y-1325z',
                23:'1443x2309y-997z',
                24:'147x2817y-669z',
                25:'149x118y-2893z',
                26:'1523x1888y-1588z',
                27:'1559x2071y-1299z',
                28:'1565x2410y-383z',
                29:'1567x2238y-969z',
                30:'160x779y-2788z',
                31:'1631x1817y-1563z',
                32:'166x304y-2879z',
                33:'1673x1996y-1273z',
                34:'1688x2161y-942z',
                35:'168x2428y-1576z',
                36:'1691x2328y-355z',
                37:'1735x1740y-1539z',
                38:'1784x1915y-1247z',
                39:'179x127y-2891z',
                40:'1805x2076y-915z',
                41:'1813x2239y-326z',
                42:'1835x1657y-1514z',
                43:'1891x1828y-1221z',
                44:'1917x1985y-887z',
                45:'1930x2143y-297z',
                46:'1931x1568y-1489z',
                47:'196x319y-2875z',
                48:'1993x1734y-1195z',
                49:'19x143y-2896z',
                50:'2022x1474y-1464z',
                51:'2025x1888y-859z',
                52:'2041x2041y-268z',
                53:'208x796y-2780z',
                54:'2090x1635y-1168z',
                55:'2128x1785y-832z',
                56:'2147x1933y-239z',
                57:'2182x1530y-1142z',
                58:'2225x1676y-804z',
                59:'2247x1820y-210z',
                60:'228x2612y-1237z',
                61:'229x332y-2871z',
                62:'230x2225y-1845z',
                63:'2316x1562y-776z',
                64:'2341x1701y-182z',
                65:'258x811y-2772z',
                66:'264x342y-2867z',
                67:'27x37y-2899z',
                68:'295x2812y-640z',
                69:'297x2431y-1552z',
                70:'2x86y-2898z',
                71:'300x350y-2863z',
                72:'310x822y-2763z',
                73:'32x170y-2894z',
                74:'338x354y-2858z',
                75:'33x711y-2811z',
                76:'349x2228y-1822z',
                77:'364x830y-2754z',
                78:'366x2609y-1211z',
                79:'377x355y-2853z',
                80:'40x2417y-1600z',
                81:'416x354y-2847z',
                82:'419x834y-2745z',
                83:'426x2427y-1527z',
                84:'443x2799y-612z',
                85:'457x349y-2842z',
                86:'469x2224y-1799z',
                87:'476x835y-2735z',
                88:'47x196y-2892z',
                89:'48x58y-2899z',
                90:'498x340y-2836z',
                91:'505x2598y-1185z',
                92:'533x832y-2726z',
                93:'556x2416y-1502z',
                94:'589x2214y-1777z',
                95:'590x2778y-584z',
                96:'592x825y-2716z',
                97:'643x2579y-1158z',
                98:'651x814y-2705z',
                99:'66x221y-2890z',
                100:'686x2398y-1478z',
                101:'70x76y-2898z',
                102:'710x2197y-1754z',
                103:'711x799y-2695z',
                104:'736x2749y-555z',
                105:'73x736y-2804z',
                106:'771x780y-2684z',
                107:'780x2553y-1132z',
                108:'815x2373y-1453z',
                109:'830x2173y-1730z',
                110:'830x756y-2673z',
                111:'87x244y-2888z',
                112:'881x2712y-527z',
                113:'890x729y-2661z',
                114:'916x2519y-1105z',
                115:'91x2608y-1264z',
                116:'944x2340y-1427z',
                117:'948x697y-2650z',
                118:'949x2142y-1707z',
                119:'95x93y-2896z',
                120:'9x114y-2897z',
                121:'9x14y-2899z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2900three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire2900three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2900THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2900THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2900THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE2900THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2900THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three29004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2900THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2900THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2900THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three29004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three29004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2900THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2900THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2900THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2900three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                